/* hashmultimap.vala
 *
 * Copyright (C) 2009  Ali Sabil
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Ali Sabil <ali.sabil@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>


#define GEE_TYPE_MULTI_MAP (gee_multi_map_get_type ())
#define GEE_MULTI_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_MULTI_MAP, GeeMultiMap))
#define GEE_IS_MULTI_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_MULTI_MAP))
#define GEE_MULTI_MAP_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_MULTI_MAP, GeeMultiMapIface))

typedef struct _GeeMultiMap GeeMultiMap;
typedef struct _GeeMultiMapIface GeeMultiMapIface;

#define GEE_TYPE_ITERABLE (gee_iterable_get_type ())
#define GEE_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ITERABLE, GeeIterable))
#define GEE_IS_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ITERABLE))
#define GEE_ITERABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_ITERABLE, GeeIterableIface))

typedef struct _GeeIterable GeeIterable;
typedef struct _GeeIterableIface GeeIterableIface;

#define GEE_TYPE_ITERATOR (gee_iterator_get_type ())
#define GEE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ITERATOR, GeeIterator))
#define GEE_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ITERATOR))
#define GEE_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_ITERATOR, GeeIteratorIface))

typedef struct _GeeIterator GeeIterator;
typedef struct _GeeIteratorIface GeeIteratorIface;

#define GEE_TYPE_COLLECTION (gee_collection_get_type ())
#define GEE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_COLLECTION, GeeCollection))
#define GEE_IS_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_COLLECTION))
#define GEE_COLLECTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_COLLECTION, GeeCollectionIface))

typedef struct _GeeCollection GeeCollection;
typedef struct _GeeCollectionIface GeeCollectionIface;

#define GEE_TYPE_SET (gee_set_get_type ())
#define GEE_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_SET, GeeSet))
#define GEE_IS_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_SET))
#define GEE_SET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_SET, GeeSetIface))

typedef struct _GeeSet GeeSet;
typedef struct _GeeSetIface GeeSetIface;

#define GEE_TYPE_MULTI_SET (gee_multi_set_get_type ())
#define GEE_MULTI_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_MULTI_SET, GeeMultiSet))
#define GEE_IS_MULTI_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_MULTI_SET))
#define GEE_MULTI_SET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_MULTI_SET, GeeMultiSetIface))

typedef struct _GeeMultiSet GeeMultiSet;
typedef struct _GeeMultiSetIface GeeMultiSetIface;

#define GEE_TYPE_HASH_MULTI_MAP (gee_hash_multi_map_get_type ())
#define GEE_HASH_MULTI_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_HASH_MULTI_MAP, GeeHashMultiMap))
#define GEE_HASH_MULTI_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_HASH_MULTI_MAP, GeeHashMultiMapClass))
#define GEE_IS_HASH_MULTI_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_HASH_MULTI_MAP))
#define GEE_IS_HASH_MULTI_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_HASH_MULTI_MAP))
#define GEE_HASH_MULTI_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_HASH_MULTI_MAP, GeeHashMultiMapClass))

typedef struct _GeeHashMultiMap GeeHashMultiMap;
typedef struct _GeeHashMultiMapClass GeeHashMultiMapClass;
typedef struct _GeeHashMultiMapPrivate GeeHashMultiMapPrivate;

#define GEE_TYPE_MAP (gee_map_get_type ())
#define GEE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_MAP, GeeMap))
#define GEE_IS_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_MAP))
#define GEE_MAP_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_MAP, GeeMapIface))

typedef struct _GeeMap GeeMap;
typedef struct _GeeMapIface GeeMapIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GEE_TYPE_ABSTRACT_MAP (gee_abstract_map_get_type ())
#define GEE_ABSTRACT_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap))
#define GEE_ABSTRACT_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ABSTRACT_MAP, GeeAbstractMapClass))
#define GEE_IS_ABSTRACT_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ABSTRACT_MAP))
#define GEE_IS_ABSTRACT_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ABSTRACT_MAP))
#define GEE_ABSTRACT_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ABSTRACT_MAP, GeeAbstractMapClass))

typedef struct _GeeAbstractMap GeeAbstractMap;
typedef struct _GeeAbstractMapClass GeeAbstractMapClass;

#define GEE_TYPE_HASH_MAP (gee_hash_map_get_type ())
#define GEE_HASH_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_HASH_MAP, GeeHashMap))
#define GEE_HASH_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_HASH_MAP, GeeHashMapClass))
#define GEE_IS_HASH_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_HASH_MAP))
#define GEE_IS_HASH_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_HASH_MAP))
#define GEE_HASH_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_HASH_MAP, GeeHashMapClass))

typedef struct _GeeHashMap GeeHashMap;
typedef struct _GeeHashMapClass GeeHashMapClass;

#define GEE_TYPE_ABSTRACT_COLLECTION (gee_abstract_collection_get_type ())
#define GEE_ABSTRACT_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection))
#define GEE_ABSTRACT_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollectionClass))
#define GEE_IS_ABSTRACT_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ABSTRACT_COLLECTION))
#define GEE_IS_ABSTRACT_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ABSTRACT_COLLECTION))
#define GEE_ABSTRACT_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollectionClass))

typedef struct _GeeAbstractCollection GeeAbstractCollection;
typedef struct _GeeAbstractCollectionClass GeeAbstractCollectionClass;

#define GEE_TYPE_ABSTRACT_SET (gee_abstract_set_get_type ())
#define GEE_ABSTRACT_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ABSTRACT_SET, GeeAbstractSet))
#define GEE_ABSTRACT_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ABSTRACT_SET, GeeAbstractSetClass))
#define GEE_IS_ABSTRACT_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ABSTRACT_SET))
#define GEE_IS_ABSTRACT_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ABSTRACT_SET))
#define GEE_ABSTRACT_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ABSTRACT_SET, GeeAbstractSetClass))

typedef struct _GeeAbstractSet GeeAbstractSet;
typedef struct _GeeAbstractSetClass GeeAbstractSetClass;

#define GEE_TYPE_HASH_SET (gee_hash_set_get_type ())
#define GEE_HASH_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_HASH_SET, GeeHashSet))
#define GEE_HASH_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_HASH_SET, GeeHashSetClass))
#define GEE_IS_HASH_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_HASH_SET))
#define GEE_IS_HASH_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_HASH_SET))
#define GEE_HASH_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_HASH_SET, GeeHashSetClass))

typedef struct _GeeHashSet GeeHashSet;
typedef struct _GeeHashSetClass GeeHashSetClass;

#define GEE_TYPE_READ_ONLY_COLLECTION (gee_read_only_collection_get_type ())
#define GEE_READ_ONLY_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_READ_ONLY_COLLECTION, GeeReadOnlyCollection))
#define GEE_READ_ONLY_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_READ_ONLY_COLLECTION, GeeReadOnlyCollectionClass))
#define GEE_IS_READ_ONLY_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_READ_ONLY_COLLECTION))
#define GEE_IS_READ_ONLY_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_READ_ONLY_COLLECTION))
#define GEE_READ_ONLY_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_READ_ONLY_COLLECTION, GeeReadOnlyCollectionClass))

typedef struct _GeeReadOnlyCollection GeeReadOnlyCollection;
typedef struct _GeeReadOnlyCollectionClass GeeReadOnlyCollectionClass;

#define GEE_TYPE_READ_ONLY_SET (gee_read_only_set_get_type ())
#define GEE_READ_ONLY_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_READ_ONLY_SET, GeeReadOnlySet))
#define GEE_READ_ONLY_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_READ_ONLY_SET, GeeReadOnlySetClass))
#define GEE_IS_READ_ONLY_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_READ_ONLY_SET))
#define GEE_IS_READ_ONLY_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_READ_ONLY_SET))
#define GEE_READ_ONLY_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_READ_ONLY_SET, GeeReadOnlySetClass))

typedef struct _GeeReadOnlySet GeeReadOnlySet;
typedef struct _GeeReadOnlySetClass GeeReadOnlySetClass;

#define GEE_TYPE_HASH_MULTI_SET (gee_hash_multi_set_get_type ())
#define GEE_HASH_MULTI_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_HASH_MULTI_SET, GeeHashMultiSet))
#define GEE_HASH_MULTI_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_HASH_MULTI_SET, GeeHashMultiSetClass))
#define GEE_IS_HASH_MULTI_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_HASH_MULTI_SET))
#define GEE_IS_HASH_MULTI_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_HASH_MULTI_SET))
#define GEE_HASH_MULTI_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_HASH_MULTI_SET, GeeHashMultiSetClass))

typedef struct _GeeHashMultiSet GeeHashMultiSet;
typedef struct _GeeHashMultiSetClass GeeHashMultiSetClass;

#define GEE_TYPE_ABSTRACT_LIST (gee_abstract_list_get_type ())
#define GEE_ABSTRACT_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ABSTRACT_LIST, GeeAbstractList))
#define GEE_ABSTRACT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ABSTRACT_LIST, GeeAbstractListClass))
#define GEE_IS_ABSTRACT_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ABSTRACT_LIST))
#define GEE_IS_ABSTRACT_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ABSTRACT_LIST))
#define GEE_ABSTRACT_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ABSTRACT_LIST, GeeAbstractListClass))

typedef struct _GeeAbstractList GeeAbstractList;
typedef struct _GeeAbstractListClass GeeAbstractListClass;

#define GEE_TYPE_ARRAY_LIST (gee_array_list_get_type ())
#define GEE_ARRAY_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ARRAY_LIST, GeeArrayList))
#define GEE_ARRAY_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ARRAY_LIST, GeeArrayListClass))
#define GEE_IS_ARRAY_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ARRAY_LIST))
#define GEE_IS_ARRAY_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ARRAY_LIST))
#define GEE_ARRAY_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ARRAY_LIST, GeeArrayListClass))

typedef struct _GeeArrayList GeeArrayList;
typedef struct _GeeArrayListClass GeeArrayListClass;

struct _GeeIteratorIface {
	GTypeInterface parent_iface;
	gboolean (*next) (GeeIterator* self);
	gboolean (*has_next) (GeeIterator* self);
	gboolean (*first) (GeeIterator* self);
	gpointer (*get) (GeeIterator* self);
	void (*remove) (GeeIterator* self);
};

struct _GeeIterableIface {
	GTypeInterface parent_iface;
	GeeIterator* (*iterator) (GeeIterable* self);
	GType (*get_element_type) (GeeIterable* self);
};

struct _GeeCollectionIface {
	GTypeInterface parent_iface;
	gboolean (*contains) (GeeCollection* self, gconstpointer item);
	gboolean (*add) (GeeCollection* self, gconstpointer item);
	gboolean (*remove) (GeeCollection* self, gconstpointer item);
	void (*clear) (GeeCollection* self);
	gboolean (*add_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*contains_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*remove_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*retain_all) (GeeCollection* self, GeeCollection* collection);
	gpointer* (*to_array) (GeeCollection* self, int* result_length1);
	gint (*get_size) (GeeCollection* self);
	gboolean (*get_is_empty) (GeeCollection* self);
	GeeCollection* (*get_read_only_view) (GeeCollection* self);
};

struct _GeeSetIface {
	GTypeInterface parent_iface;
	GeeSet* (*get_read_only_view) (GeeSet* self);
};

struct _GeeMultiSetIface {
	GTypeInterface parent_iface;
	gint (*count) (GeeMultiSet* self, gconstpointer item);
};

struct _GeeMultiMapIface {
	GTypeInterface parent_iface;
	GeeSet* (*get_keys) (GeeMultiMap* self);
	GeeMultiSet* (*get_all_keys) (GeeMultiMap* self);
	GeeCollection* (*get_values) (GeeMultiMap* self);
	gboolean (*contains) (GeeMultiMap* self, gconstpointer key);
	GeeCollection* (*get) (GeeMultiMap* self, gconstpointer key);
	void (*set) (GeeMultiMap* self, gconstpointer key, gconstpointer value);
	gboolean (*remove) (GeeMultiMap* self, gconstpointer key, gconstpointer value);
	gboolean (*remove_all) (GeeMultiMap* self, gconstpointer key);
	void (*clear) (GeeMultiMap* self);
	gint (*get_size) (GeeMultiMap* self);
};

struct _GeeHashMultiMap {
	GObject parent_instance;
	GeeHashMultiMapPrivate * priv;
};

struct _GeeHashMultiMapClass {
	GObjectClass parent_class;
};

struct _GeeMapIface {
	GTypeInterface parent_iface;
	GeeSet* (*get_keys) (GeeMap* self);
	GeeCollection* (*get_values) (GeeMap* self);
	gboolean (*contains) (GeeMap* self, gconstpointer key);
	gpointer (*get) (GeeMap* self, gconstpointer key);
	void (*set) (GeeMap* self, gconstpointer key, gconstpointer value);
	gboolean (*remove) (GeeMap* self, gconstpointer key, gpointer* value);
	void (*clear) (GeeMap* self);
	void (*set_all) (GeeMap* self, GeeMap* map);
	gboolean (*remove_all) (GeeMap* self, GeeMap* map);
	gboolean (*contains_all) (GeeMap* self, GeeMap* map);
	gint (*get_size) (GeeMap* self);
	gboolean (*get_is_empty) (GeeMap* self);
	GeeMap* (*get_read_only_view) (GeeMap* self);
};

struct _GeeHashMultiMapPrivate {
	GType k_type;
	GBoxedCopyFunc k_dup_func;
	GDestroyNotify k_destroy_func;
	GType v_type;
	GBoxedCopyFunc v_dup_func;
	GDestroyNotify v_destroy_func;
	GHashFunc _key_hash_func;
	GEqualFunc _key_equal_func;
	GHashFunc _value_hash_func;
	GEqualFunc _value_equal_func;
	GeeMap* _items;
	gint _nitems;
	GeeSet* _empty_value_set;
};


static gpointer gee_hash_multi_map_parent_class = NULL;
static GeeMultiMapIface* gee_hash_multi_map_gee_multi_map_parent_iface = NULL;

GType gee_iterator_get_type (void);
GType gee_iterable_get_type (void);
GType gee_collection_get_type (void);
GType gee_set_get_type (void);
GType gee_multi_set_get_type (void);
GType gee_multi_map_get_type (void);
GType gee_hash_multi_map_get_type (void);
GType gee_map_get_type (void);
#define GEE_HASH_MULTI_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEE_TYPE_HASH_MULTI_MAP, GeeHashMultiMapPrivate))
enum  {
	GEE_HASH_MULTI_MAP_DUMMY_PROPERTY,
	GEE_HASH_MULTI_MAP_SIZE,
	GEE_HASH_MULTI_MAP_KEY_HASH_FUNC,
	GEE_HASH_MULTI_MAP_KEY_EQUAL_FUNC,
	GEE_HASH_MULTI_MAP_VALUE_HASH_FUNC,
	GEE_HASH_MULTI_MAP_VALUE_EQUAL_FUNC,
	GEE_HASH_MULTI_MAP_K_TYPE,
	GEE_HASH_MULTI_MAP_K_DUP_FUNC,
	GEE_HASH_MULTI_MAP_K_DESTROY_FUNC,
	GEE_HASH_MULTI_MAP_V_TYPE,
	GEE_HASH_MULTI_MAP_V_DUP_FUNC,
	GEE_HASH_MULTI_MAP_V_DESTROY_FUNC
};
GHashFunc gee_functions_get_hash_func_for (GType t);
GEqualFunc gee_functions_get_equal_func_for (GType t);
static void gee_hash_multi_map_set_key_hash_func (GeeHashMultiMap* self, GHashFunc value);
static void gee_hash_multi_map_set_key_equal_func (GeeHashMultiMap* self, GEqualFunc value);
static void gee_hash_multi_map_set_value_hash_func (GeeHashMultiMap* self, GHashFunc value);
static void gee_hash_multi_map_set_value_equal_func (GeeHashMultiMap* self, GEqualFunc value);
GeeHashMap* gee_hash_map_new (GType k_type, GBoxedCopyFunc k_dup_func, GDestroyNotify k_destroy_func, GType v_type, GBoxedCopyFunc v_dup_func, GDestroyNotify v_destroy_func, GHashFunc key_hash_func, GEqualFunc key_equal_func, GEqualFunc value_equal_func);
GeeHashMap* gee_hash_map_construct (GType object_type, GType k_type, GBoxedCopyFunc k_dup_func, GDestroyNotify k_destroy_func, GType v_type, GBoxedCopyFunc v_dup_func, GDestroyNotify v_destroy_func, GHashFunc key_hash_func, GEqualFunc key_equal_func, GEqualFunc value_equal_func);
GType gee_abstract_map_get_type (void);
GType gee_hash_map_get_type (void);
GeeHashSet* gee_hash_set_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GHashFunc hash_func, GEqualFunc equal_func);
GeeHashSet* gee_hash_set_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GHashFunc hash_func, GEqualFunc equal_func);
GType gee_abstract_collection_get_type (void);
GType gee_abstract_set_get_type (void);
GType gee_hash_set_get_type (void);
GeeReadOnlySet* gee_read_only_set_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GeeSet* set);
GeeReadOnlySet* gee_read_only_set_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GeeSet* set);
GType gee_read_only_collection_get_type (void);
GType gee_read_only_set_get_type (void);
GeeHashMultiMap* gee_hash_multi_map_new (GType k_type, GBoxedCopyFunc k_dup_func, GDestroyNotify k_destroy_func, GType v_type, GBoxedCopyFunc v_dup_func, GDestroyNotify v_destroy_func, GHashFunc key_hash_func, GEqualFunc key_equal_func, GHashFunc value_hash_func, GEqualFunc value_equal_func);
GeeHashMultiMap* gee_hash_multi_map_construct (GType object_type, GType k_type, GBoxedCopyFunc k_dup_func, GDestroyNotify k_destroy_func, GType v_type, GBoxedCopyFunc v_dup_func, GDestroyNotify v_destroy_func, GHashFunc key_hash_func, GEqualFunc key_equal_func, GHashFunc value_hash_func, GEqualFunc value_equal_func);
GeeSet* gee_map_get_keys (GeeMap* self);
static GeeSet* gee_hash_multi_map_real_get_keys (GeeMultiMap* base);
GeeHashMultiSet* gee_hash_multi_set_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GHashFunc hash_func, GEqualFunc equal_func);
GeeHashMultiSet* gee_hash_multi_set_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GHashFunc hash_func, GEqualFunc equal_func);
GType gee_hash_multi_set_get_type (void);
GeeIterator* gee_iterable_iterator (GeeIterable* self);
gboolean gee_iterator_next (GeeIterator* self);
gpointer gee_iterator_get (GeeIterator* self);
gpointer gee_map_get (GeeMap* self, gconstpointer key);
gint gee_collection_get_size (GeeCollection* self);
gboolean gee_collection_add (GeeCollection* self, gconstpointer item);
static GeeMultiSet* gee_hash_multi_map_real_get_all_keys (GeeMultiMap* base);
GeeArrayList* gee_array_list_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GEqualFunc equal_func);
GeeArrayList* gee_array_list_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GEqualFunc equal_func);
GType gee_abstract_list_get_type (void);
GType gee_array_list_get_type (void);
gboolean gee_abstract_collection_add (GeeAbstractCollection* self, gconstpointer item);
static GeeCollection* gee_hash_multi_map_real_get_values (GeeMultiMap* base);
gboolean gee_map_contains (GeeMap* self, gconstpointer key);
static gboolean gee_hash_multi_map_real_contains (GeeMultiMap* base, gconstpointer key);
GeeReadOnlyCollection* gee_read_only_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GeeCollection* collection);
GeeReadOnlyCollection* gee_read_only_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GeeCollection* collection);
static GeeCollection* gee_hash_multi_map_real_get (GeeMultiMap* base, gconstpointer key);
void gee_map_set (GeeMap* self, gconstpointer key, gconstpointer value);
static void gee_hash_multi_map_real_set (GeeMultiMap* base, gconstpointer key, gconstpointer value);
gboolean gee_collection_contains (GeeCollection* self, gconstpointer item);
gboolean gee_collection_remove (GeeCollection* self, gconstpointer item);
gboolean gee_map_remove (GeeMap* self, gconstpointer key, gpointer* value);
static gboolean gee_hash_multi_map_real_remove (GeeMultiMap* base, gconstpointer key, gconstpointer value);
static gboolean gee_hash_multi_map_real_remove_all (GeeMultiMap* base, gconstpointer key);
void gee_map_clear (GeeMap* self);
static void gee_hash_multi_map_real_clear (GeeMultiMap* base);
GHashFunc gee_hash_multi_map_get_key_hash_func (GeeHashMultiMap* self);
GEqualFunc gee_hash_multi_map_get_key_equal_func (GeeHashMultiMap* self);
GHashFunc gee_hash_multi_map_get_value_hash_func (GeeHashMultiMap* self);
GEqualFunc gee_hash_multi_map_get_value_equal_func (GeeHashMultiMap* self);
static void gee_hash_multi_map_finalize (GObject* obj);
gint gee_multi_map_get_size (GeeMultiMap* self);
static void gee_hash_multi_map_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void gee_hash_multi_map_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



GeeHashMultiMap* gee_hash_multi_map_construct (GType object_type, GType k_type, GBoxedCopyFunc k_dup_func, GDestroyNotify k_destroy_func, GType v_type, GBoxedCopyFunc v_dup_func, GDestroyNotify v_destroy_func, GHashFunc key_hash_func, GEqualFunc key_equal_func, GHashFunc value_hash_func, GEqualFunc value_equal_func) {
	GeeHashMultiMap * self;
	GeeMap* _tmp0_;
	GeeSet* _tmp2_;
	GeeHashSet* _tmp1_;
	self = (GeeHashMultiMap*) g_object_new (object_type, NULL);
	self->priv->k_type = k_type;
	self->priv->k_dup_func = k_dup_func;
	self->priv->k_destroy_func = k_destroy_func;
	self->priv->v_type = v_type;
	self->priv->v_dup_func = v_dup_func;
	self->priv->v_destroy_func = v_destroy_func;
	if (key_hash_func == NULL) {
		key_hash_func = gee_functions_get_hash_func_for (k_type);
	}
	if (key_equal_func == NULL) {
		key_equal_func = gee_functions_get_equal_func_for (k_type);
	}
	if (value_hash_func == NULL) {
		value_hash_func = gee_functions_get_hash_func_for (v_type);
	}
	if (value_equal_func == NULL) {
		value_equal_func = gee_functions_get_equal_func_for (v_type);
	}
	gee_hash_multi_map_set_key_hash_func (self, key_hash_func);
	gee_hash_multi_map_set_key_equal_func (self, key_equal_func);
	gee_hash_multi_map_set_value_hash_func (self, value_hash_func);
	gee_hash_multi_map_set_value_equal_func (self, value_equal_func);
	self->priv->_items = (_tmp0_ = (GeeMap*) gee_hash_map_new (k_type, (GBoxedCopyFunc) k_dup_func, k_destroy_func, GEE_TYPE_SET, (GBoxedCopyFunc) g_object_ref, g_object_unref, key_hash_func, key_equal_func, g_direct_equal), _g_object_unref0 (self->priv->_items), _tmp0_);
	self->priv->_empty_value_set = (_tmp2_ = (GeeSet*) gee_read_only_set_new (v_type, (GBoxedCopyFunc) v_dup_func, v_destroy_func, (GeeSet*) (_tmp1_ = gee_hash_set_new (v_type, (GBoxedCopyFunc) v_dup_func, v_destroy_func, self->priv->_value_hash_func, self->priv->_value_equal_func))), _g_object_unref0 (self->priv->_empty_value_set), _tmp2_);
	_g_object_unref0 (_tmp1_);
	return self;
}


GeeHashMultiMap* gee_hash_multi_map_new (GType k_type, GBoxedCopyFunc k_dup_func, GDestroyNotify k_destroy_func, GType v_type, GBoxedCopyFunc v_dup_func, GDestroyNotify v_destroy_func, GHashFunc key_hash_func, GEqualFunc key_equal_func, GHashFunc value_hash_func, GEqualFunc value_equal_func) {
	return gee_hash_multi_map_construct (GEE_TYPE_HASH_MULTI_MAP, k_type, k_dup_func, k_destroy_func, v_type, v_dup_func, v_destroy_func, key_hash_func, key_equal_func, value_hash_func, value_equal_func);
}


static GeeSet* gee_hash_multi_map_real_get_keys (GeeMultiMap* base) {
	GeeHashMultiMap * self;
	GeeSet* result;
	self = (GeeHashMultiMap*) base;
	result = gee_map_get_keys (self->priv->_items);
	return result;
}


static GeeMultiSet* gee_hash_multi_map_real_get_all_keys (GeeMultiMap* base) {
	GeeHashMultiMap * self;
	GeeMultiSet* result;
	GeeMultiSet* _result_;
	self = (GeeHashMultiMap*) base;
	_result_ = (GeeMultiSet*) gee_hash_multi_set_new (self->priv->k_type, (GBoxedCopyFunc) self->priv->k_dup_func, self->priv->k_destroy_func, self->priv->_key_hash_func, self->priv->_key_equal_func);
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _key_it;
		_key_it = (_tmp1_ = gee_iterable_iterator ((GeeIterable*) (_tmp0_ = gee_map_get_keys (self->priv->_items))), _g_object_unref0 (_tmp0_), _tmp1_);
		while (TRUE) {
			gpointer key;
			if (!gee_iterator_next (_key_it)) {
				break;
			}
			key = gee_iterator_get (_key_it);
			{
				gint i;
				i = 0;
				{
					gboolean _tmp2_;
					_tmp2_ = TRUE;
					while (TRUE) {
						GeeCollection* _tmp3_;
						gboolean _tmp4_;
						if (!_tmp2_) {
							i++;
						}
						_tmp2_ = FALSE;
						if ((_tmp4_ = !(i < gee_collection_get_size (_tmp3_ = (GeeCollection*) gee_map_get (self->priv->_items, key))), _g_object_unref0 (_tmp3_), _tmp4_)) {
							break;
						}
						gee_collection_add ((GeeCollection*) _result_, key);
					}
				}
			}
			((key == NULL) || (self->priv->k_destroy_func == NULL)) ? NULL : (key = (self->priv->k_destroy_func (key), NULL));
		}
		_g_object_unref0 (_key_it);
	}
	result = _result_;
	return result;
}


static GeeCollection* gee_hash_multi_map_real_get_values (GeeMultiMap* base) {
	GeeHashMultiMap * self;
	GeeCollection* result;
	GeeArrayList* _result_;
	self = (GeeHashMultiMap*) base;
	_result_ = gee_array_list_new (self->priv->v_type, (GBoxedCopyFunc) self->priv->v_dup_func, self->priv->v_destroy_func, self->priv->_value_equal_func);
	{
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
		GeeIterator* _key_it;
		_key_it = (_tmp1_ = gee_iterable_iterator ((GeeIterable*) (_tmp0_ = gee_map_get_keys (self->priv->_items))), _g_object_unref0 (_tmp0_), _tmp1_);
		while (TRUE) {
			gpointer key;
			if (!gee_iterator_next (_key_it)) {
				break;
			}
			key = gee_iterator_get (_key_it);
			{
				GeeCollection* _tmp2_;
				GeeIterator* _tmp3_;
				GeeIterator* _value_it;
				_value_it = (_tmp3_ = gee_iterable_iterator ((GeeIterable*) (_tmp2_ = (GeeCollection*) gee_map_get (self->priv->_items, key))), _g_object_unref0 (_tmp2_), _tmp3_);
				while (TRUE) {
					gpointer value;
					if (!gee_iterator_next (_value_it)) {
						break;
					}
					value = gee_iterator_get (_value_it);
					gee_abstract_collection_add ((GeeAbstractCollection*) _result_, value);
					((value == NULL) || (self->priv->v_destroy_func == NULL)) ? NULL : (value = (self->priv->v_destroy_func (value), NULL));
				}
				_g_object_unref0 (_value_it);
			}
			((key == NULL) || (self->priv->k_destroy_func == NULL)) ? NULL : (key = (self->priv->k_destroy_func (key), NULL));
		}
		_g_object_unref0 (_key_it);
	}
	result = (GeeCollection*) _result_;
	return result;
}


static gboolean gee_hash_multi_map_real_contains (GeeMultiMap* base, gconstpointer key) {
	GeeHashMultiMap * self;
	gboolean result;
	self = (GeeHashMultiMap*) base;
	result = gee_map_contains (self->priv->_items, key);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GeeCollection* gee_hash_multi_map_real_get (GeeMultiMap* base, gconstpointer key) {
	GeeHashMultiMap * self;
	GeeCollection* result;
	self = (GeeHashMultiMap*) base;
	if (gee_map_contains (self->priv->_items, key)) {
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		result = (_tmp1_ = (GeeCollection*) gee_read_only_collection_new (self->priv->v_type, (GBoxedCopyFunc) self->priv->v_dup_func, self->priv->v_destroy_func, _tmp0_ = (GeeCollection*) gee_map_get (self->priv->_items, key)), _g_object_unref0 (_tmp0_), _tmp1_);
		return result;
	} else {
		result = _g_object_ref0 ((GeeCollection*) self->priv->_empty_value_set);
		return result;
	}
}


static void gee_hash_multi_map_real_set (GeeMultiMap* base, gconstpointer key, gconstpointer value) {
	GeeHashMultiMap * self;
	self = (GeeHashMultiMap*) base;
	if (gee_map_contains (self->priv->_items, key)) {
		GeeCollection* _tmp0_;
		gboolean _tmp1_;
		if ((_tmp1_ = gee_collection_add (_tmp0_ = (GeeCollection*) gee_map_get (self->priv->_items, key), value), _g_object_unref0 (_tmp0_), _tmp1_)) {
			self->priv->_nitems++;
		}
	} else {
		GeeHashSet* s;
		s = gee_hash_set_new (self->priv->v_type, (GBoxedCopyFunc) self->priv->v_dup_func, self->priv->v_destroy_func, self->priv->_value_hash_func, self->priv->_value_equal_func);
		gee_abstract_collection_add ((GeeAbstractCollection*) s, value);
		gee_map_set (self->priv->_items, key, (GeeCollection*) s);
		self->priv->_nitems++;
		_g_object_unref0 (s);
	}
}


static gboolean gee_hash_multi_map_real_remove (GeeMultiMap* base, gconstpointer key, gconstpointer value) {
	GeeHashMultiMap * self;
	gboolean result;
	self = (GeeHashMultiMap*) base;
	if (gee_map_contains (self->priv->_items, key)) {
		GeeCollection* values;
		values = (GeeCollection*) gee_map_get (self->priv->_items, key);
		if (gee_collection_contains (values, value)) {
			gee_collection_remove (values, value);
			self->priv->_nitems--;
			if (gee_collection_get_size (values) == 0) {
				gee_map_remove (self->priv->_items, key, NULL);
			}
			result = TRUE;
			_g_object_unref0 (values);
			return result;
		}
		_g_object_unref0 (values);
	}
	result = FALSE;
	return result;
}


static gboolean gee_hash_multi_map_real_remove_all (GeeMultiMap* base, gconstpointer key) {
	GeeHashMultiMap * self;
	gboolean result;
	self = (GeeHashMultiMap*) base;
	if (gee_map_contains (self->priv->_items, key)) {
		GeeCollection* _tmp0_;
		gint _tmp1_;
		gint size;
		size = (_tmp1_ = gee_collection_get_size (_tmp0_ = (GeeCollection*) gee_map_get (self->priv->_items, key)), _g_object_unref0 (_tmp0_), _tmp1_);
		if (gee_map_remove (self->priv->_items, key, NULL)) {
			self->priv->_nitems = self->priv->_nitems - size;
			result = TRUE;
			return result;
		}
	}
	result = FALSE;
	return result;
}


static void gee_hash_multi_map_real_clear (GeeMultiMap* base) {
	GeeHashMultiMap * self;
	self = (GeeHashMultiMap*) base;
	gee_map_clear (self->priv->_items);
	self->priv->_nitems = 0;
}


static gint gee_hash_multi_map_real_get_size (GeeMultiMap* base) {
	gint result;
	GeeHashMultiMap* self;
	self = (GeeHashMultiMap*) base;
	result = self->priv->_nitems;
	return result;
}


GHashFunc gee_hash_multi_map_get_key_hash_func (GeeHashMultiMap* self) {
	GHashFunc result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_key_hash_func;
	return result;
}


static void gee_hash_multi_map_set_key_hash_func (GeeHashMultiMap* self, GHashFunc value) {
	g_return_if_fail (self != NULL);
	self->priv->_key_hash_func = value;
	g_object_notify ((GObject *) self, "key-hash-func");
}


GEqualFunc gee_hash_multi_map_get_key_equal_func (GeeHashMultiMap* self) {
	GEqualFunc result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_key_equal_func;
	return result;
}


static void gee_hash_multi_map_set_key_equal_func (GeeHashMultiMap* self, GEqualFunc value) {
	g_return_if_fail (self != NULL);
	self->priv->_key_equal_func = value;
	g_object_notify ((GObject *) self, "key-equal-func");
}


GHashFunc gee_hash_multi_map_get_value_hash_func (GeeHashMultiMap* self) {
	GHashFunc result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_value_hash_func;
	return result;
}


static void gee_hash_multi_map_set_value_hash_func (GeeHashMultiMap* self, GHashFunc value) {
	g_return_if_fail (self != NULL);
	self->priv->_value_hash_func = value;
	g_object_notify ((GObject *) self, "value-hash-func");
}


GEqualFunc gee_hash_multi_map_get_value_equal_func (GeeHashMultiMap* self) {
	GEqualFunc result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_value_equal_func;
	return result;
}


static void gee_hash_multi_map_set_value_equal_func (GeeHashMultiMap* self, GEqualFunc value) {
	g_return_if_fail (self != NULL);
	self->priv->_value_equal_func = value;
	g_object_notify ((GObject *) self, "value-equal-func");
}


static void gee_hash_multi_map_class_init (GeeHashMultiMapClass * klass) {
	gee_hash_multi_map_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GeeHashMultiMapPrivate));
	G_OBJECT_CLASS (klass)->get_property = gee_hash_multi_map_get_property;
	G_OBJECT_CLASS (klass)->set_property = gee_hash_multi_map_set_property;
	G_OBJECT_CLASS (klass)->finalize = gee_hash_multi_map_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_K_TYPE, g_param_spec_gtype ("k-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_K_DUP_FUNC, g_param_spec_pointer ("k-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_K_DESTROY_FUNC, g_param_spec_pointer ("k-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_V_TYPE, g_param_spec_gtype ("v-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_V_DUP_FUNC, g_param_spec_pointer ("v-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_V_DESTROY_FUNC, g_param_spec_pointer ("v-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_SIZE, "size");
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_KEY_HASH_FUNC, g_param_spec_pointer ("key-hash-func", "key-hash-func", "key-hash-func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_KEY_EQUAL_FUNC, g_param_spec_pointer ("key-equal-func", "key-equal-func", "key-equal-func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_VALUE_HASH_FUNC, g_param_spec_pointer ("value-hash-func", "value-hash-func", "value-hash-func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_MAP_VALUE_EQUAL_FUNC, g_param_spec_pointer ("value-equal-func", "value-equal-func", "value-equal-func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void gee_hash_multi_map_gee_multi_map_interface_init (GeeMultiMapIface * iface) {
	gee_hash_multi_map_gee_multi_map_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_keys = gee_hash_multi_map_real_get_keys;
	iface->get_all_keys = gee_hash_multi_map_real_get_all_keys;
	iface->get_values = gee_hash_multi_map_real_get_values;
	iface->contains = gee_hash_multi_map_real_contains;
	iface->get = gee_hash_multi_map_real_get;
	iface->set = gee_hash_multi_map_real_set;
	iface->remove = gee_hash_multi_map_real_remove;
	iface->remove_all = gee_hash_multi_map_real_remove_all;
	iface->clear = gee_hash_multi_map_real_clear;
	iface->get_size = gee_hash_multi_map_real_get_size;
}


static void gee_hash_multi_map_instance_init (GeeHashMultiMap * self) {
	self->priv = GEE_HASH_MULTI_MAP_GET_PRIVATE (self);
	self->priv->_nitems = 0;
}


static void gee_hash_multi_map_finalize (GObject* obj) {
	GeeHashMultiMap * self;
	self = GEE_HASH_MULTI_MAP (obj);
	_g_object_unref0 (self->priv->_items);
	_g_object_unref0 (self->priv->_empty_value_set);
	G_OBJECT_CLASS (gee_hash_multi_map_parent_class)->finalize (obj);
}


GType gee_hash_multi_map_get_type (void) {
	static GType gee_hash_multi_map_type_id = 0;
	if (gee_hash_multi_map_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GeeHashMultiMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gee_hash_multi_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GeeHashMultiMap), 0, (GInstanceInitFunc) gee_hash_multi_map_instance_init, NULL };
		static const GInterfaceInfo gee_multi_map_info = { (GInterfaceInitFunc) gee_hash_multi_map_gee_multi_map_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		gee_hash_multi_map_type_id = g_type_register_static (G_TYPE_OBJECT, "GeeHashMultiMap", &g_define_type_info, 0);
		g_type_add_interface_static (gee_hash_multi_map_type_id, GEE_TYPE_MULTI_MAP, &gee_multi_map_info);
	}
	return gee_hash_multi_map_type_id;
}


static void gee_hash_multi_map_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GeeHashMultiMap * self;
	self = GEE_HASH_MULTI_MAP (object);
	switch (property_id) {
		case GEE_HASH_MULTI_MAP_SIZE:
		g_value_set_int (value, gee_multi_map_get_size ((GeeMultiMap*) self));
		break;
		case GEE_HASH_MULTI_MAP_KEY_HASH_FUNC:
		g_value_set_pointer (value, gee_hash_multi_map_get_key_hash_func (self));
		break;
		case GEE_HASH_MULTI_MAP_KEY_EQUAL_FUNC:
		g_value_set_pointer (value, gee_hash_multi_map_get_key_equal_func (self));
		break;
		case GEE_HASH_MULTI_MAP_VALUE_HASH_FUNC:
		g_value_set_pointer (value, gee_hash_multi_map_get_value_hash_func (self));
		break;
		case GEE_HASH_MULTI_MAP_VALUE_EQUAL_FUNC:
		g_value_set_pointer (value, gee_hash_multi_map_get_value_equal_func (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gee_hash_multi_map_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GeeHashMultiMap * self;
	self = GEE_HASH_MULTI_MAP (object);
	switch (property_id) {
		case GEE_HASH_MULTI_MAP_KEY_HASH_FUNC:
		gee_hash_multi_map_set_key_hash_func (self, g_value_get_pointer (value));
		break;
		case GEE_HASH_MULTI_MAP_KEY_EQUAL_FUNC:
		gee_hash_multi_map_set_key_equal_func (self, g_value_get_pointer (value));
		break;
		case GEE_HASH_MULTI_MAP_VALUE_HASH_FUNC:
		gee_hash_multi_map_set_value_hash_func (self, g_value_get_pointer (value));
		break;
		case GEE_HASH_MULTI_MAP_VALUE_EQUAL_FUNC:
		gee_hash_multi_map_set_value_equal_func (self, g_value_get_pointer (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case GEE_HASH_MULTI_MAP_K_TYPE:
		self->priv->k_type = g_value_get_gtype (value);
		break;
		case GEE_HASH_MULTI_MAP_K_DUP_FUNC:
		self->priv->k_dup_func = g_value_get_pointer (value);
		break;
		case GEE_HASH_MULTI_MAP_K_DESTROY_FUNC:
		self->priv->k_destroy_func = g_value_get_pointer (value);
		break;
		case GEE_HASH_MULTI_MAP_V_TYPE:
		self->priv->v_type = g_value_get_gtype (value);
		break;
		case GEE_HASH_MULTI_MAP_V_DUP_FUNC:
		self->priv->v_dup_func = g_value_get_pointer (value);
		break;
		case GEE_HASH_MULTI_MAP_V_DESTROY_FUNC:
		self->priv->v_destroy_func = g_value_get_pointer (value);
		break;
	}
}




