/* hashmultiset.vala
 *
 * Copyright (C) 2009  Ali Sabil
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Ali Sabil <ali.sabil@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>


#define GEE_TYPE_ITERABLE (gee_iterable_get_type ())
#define GEE_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ITERABLE, GeeIterable))
#define GEE_IS_ITERABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ITERABLE))
#define GEE_ITERABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_ITERABLE, GeeIterableIface))

typedef struct _GeeIterable GeeIterable;
typedef struct _GeeIterableIface GeeIterableIface;

#define GEE_TYPE_ITERATOR (gee_iterator_get_type ())
#define GEE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ITERATOR, GeeIterator))
#define GEE_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ITERATOR))
#define GEE_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_ITERATOR, GeeIteratorIface))

typedef struct _GeeIterator GeeIterator;
typedef struct _GeeIteratorIface GeeIteratorIface;

#define GEE_TYPE_COLLECTION (gee_collection_get_type ())
#define GEE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_COLLECTION, GeeCollection))
#define GEE_IS_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_COLLECTION))
#define GEE_COLLECTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_COLLECTION, GeeCollectionIface))

typedef struct _GeeCollection GeeCollection;
typedef struct _GeeCollectionIface GeeCollectionIface;

#define GEE_TYPE_ABSTRACT_COLLECTION (gee_abstract_collection_get_type ())
#define GEE_ABSTRACT_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection))
#define GEE_ABSTRACT_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollectionClass))
#define GEE_IS_ABSTRACT_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ABSTRACT_COLLECTION))
#define GEE_IS_ABSTRACT_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ABSTRACT_COLLECTION))
#define GEE_ABSTRACT_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollectionClass))

typedef struct _GeeAbstractCollection GeeAbstractCollection;
typedef struct _GeeAbstractCollectionClass GeeAbstractCollectionClass;
typedef struct _GeeAbstractCollectionPrivate GeeAbstractCollectionPrivate;

#define GEE_TYPE_MULTI_SET (gee_multi_set_get_type ())
#define GEE_MULTI_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_MULTI_SET, GeeMultiSet))
#define GEE_IS_MULTI_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_MULTI_SET))
#define GEE_MULTI_SET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_MULTI_SET, GeeMultiSetIface))

typedef struct _GeeMultiSet GeeMultiSet;
typedef struct _GeeMultiSetIface GeeMultiSetIface;

#define GEE_TYPE_HASH_MULTI_SET (gee_hash_multi_set_get_type ())
#define GEE_HASH_MULTI_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_HASH_MULTI_SET, GeeHashMultiSet))
#define GEE_HASH_MULTI_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_HASH_MULTI_SET, GeeHashMultiSetClass))
#define GEE_IS_HASH_MULTI_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_HASH_MULTI_SET))
#define GEE_IS_HASH_MULTI_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_HASH_MULTI_SET))
#define GEE_HASH_MULTI_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_HASH_MULTI_SET, GeeHashMultiSetClass))

typedef struct _GeeHashMultiSet GeeHashMultiSet;
typedef struct _GeeHashMultiSetClass GeeHashMultiSetClass;
typedef struct _GeeHashMultiSetPrivate GeeHashMultiSetPrivate;

#define GEE_TYPE_ABSTRACT_MAP (gee_abstract_map_get_type ())
#define GEE_ABSTRACT_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap))
#define GEE_ABSTRACT_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_ABSTRACT_MAP, GeeAbstractMapClass))
#define GEE_IS_ABSTRACT_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_ABSTRACT_MAP))
#define GEE_IS_ABSTRACT_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_ABSTRACT_MAP))
#define GEE_ABSTRACT_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_ABSTRACT_MAP, GeeAbstractMapClass))

typedef struct _GeeAbstractMap GeeAbstractMap;
typedef struct _GeeAbstractMapClass GeeAbstractMapClass;

#define GEE_TYPE_HASH_MAP (gee_hash_map_get_type ())
#define GEE_HASH_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_HASH_MAP, GeeHashMap))
#define GEE_HASH_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_TYPE_HASH_MAP, GeeHashMapClass))
#define GEE_IS_HASH_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_HASH_MAP))
#define GEE_IS_HASH_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_TYPE_HASH_MAP))
#define GEE_HASH_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_TYPE_HASH_MAP, GeeHashMapClass))

typedef struct _GeeHashMap GeeHashMap;
typedef struct _GeeHashMapClass GeeHashMapClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GEE_HASH_MULTI_SET_TYPE_ITERATOR (gee_hash_multi_set_iterator_get_type ())
#define GEE_HASH_MULTI_SET_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_HASH_MULTI_SET_TYPE_ITERATOR, GeeHashMultiSetIterator))
#define GEE_HASH_MULTI_SET_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEE_HASH_MULTI_SET_TYPE_ITERATOR, GeeHashMultiSetIteratorClass))
#define GEE_HASH_MULTI_SET_IS_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_HASH_MULTI_SET_TYPE_ITERATOR))
#define GEE_HASH_MULTI_SET_IS_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEE_HASH_MULTI_SET_TYPE_ITERATOR))
#define GEE_HASH_MULTI_SET_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEE_HASH_MULTI_SET_TYPE_ITERATOR, GeeHashMultiSetIteratorClass))

typedef struct _GeeHashMultiSetIterator GeeHashMultiSetIterator;
typedef struct _GeeHashMultiSetIteratorClass GeeHashMultiSetIteratorClass;
typedef struct _GeeHashMultiSetIteratorPrivate GeeHashMultiSetIteratorPrivate;

#define GEE_TYPE_UPDATABLE_KEY_ITERATOR (gee_updatable_key_iterator_get_type ())
#define GEE_UPDATABLE_KEY_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEE_TYPE_UPDATABLE_KEY_ITERATOR, GeeUpdatableKeyIterator))
#define GEE_IS_UPDATABLE_KEY_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEE_TYPE_UPDATABLE_KEY_ITERATOR))
#define GEE_UPDATABLE_KEY_ITERATOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEE_TYPE_UPDATABLE_KEY_ITERATOR, GeeUpdatableKeyIteratorIface))

typedef struct _GeeUpdatableKeyIterator GeeUpdatableKeyIterator;
typedef struct _GeeUpdatableKeyIteratorIface GeeUpdatableKeyIteratorIface;

struct _GeeIteratorIface {
	GTypeInterface parent_iface;
	gboolean (*next) (GeeIterator* self);
	gboolean (*has_next) (GeeIterator* self);
	gboolean (*first) (GeeIterator* self);
	gpointer (*get) (GeeIterator* self);
	void (*remove) (GeeIterator* self);
};

struct _GeeIterableIface {
	GTypeInterface parent_iface;
	GeeIterator* (*iterator) (GeeIterable* self);
	GType (*get_element_type) (GeeIterable* self);
};

struct _GeeCollectionIface {
	GTypeInterface parent_iface;
	gboolean (*contains) (GeeCollection* self, gconstpointer item);
	gboolean (*add) (GeeCollection* self, gconstpointer item);
	gboolean (*remove) (GeeCollection* self, gconstpointer item);
	void (*clear) (GeeCollection* self);
	gboolean (*add_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*contains_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*remove_all) (GeeCollection* self, GeeCollection* collection);
	gboolean (*retain_all) (GeeCollection* self, GeeCollection* collection);
	gpointer* (*to_array) (GeeCollection* self, int* result_length1);
	gint (*get_size) (GeeCollection* self);
	gboolean (*get_is_empty) (GeeCollection* self);
	GeeCollection* (*get_read_only_view) (GeeCollection* self);
};

struct _GeeAbstractCollection {
	GObject parent_instance;
	GeeAbstractCollectionPrivate * priv;
};

struct _GeeAbstractCollectionClass {
	GObjectClass parent_class;
	gboolean (*contains) (GeeAbstractCollection* self, gconstpointer item);
	gboolean (*add) (GeeAbstractCollection* self, gconstpointer item);
	gboolean (*remove) (GeeAbstractCollection* self, gconstpointer item);
	void (*clear) (GeeAbstractCollection* self);
	gpointer* (*to_array) (GeeAbstractCollection* self, int* result_length1);
	gboolean (*add_all) (GeeAbstractCollection* self, GeeCollection* collection);
	gboolean (*contains_all) (GeeAbstractCollection* self, GeeCollection* collection);
	gboolean (*remove_all) (GeeAbstractCollection* self, GeeCollection* collection);
	gboolean (*retain_all) (GeeAbstractCollection* self, GeeCollection* collection);
	GeeIterator* (*iterator) (GeeAbstractCollection* self);
	gint (*get_size) (GeeAbstractCollection* self);
	gboolean (*get_is_empty) (GeeAbstractCollection* self);
	GeeCollection* (*get_read_only_view) (GeeAbstractCollection* self);
};

struct _GeeMultiSetIface {
	GTypeInterface parent_iface;
	gint (*count) (GeeMultiSet* self, gconstpointer item);
};

struct _GeeHashMultiSet {
	GeeAbstractCollection parent_instance;
	GeeHashMultiSetPrivate * priv;
};

struct _GeeHashMultiSetClass {
	GeeAbstractCollectionClass parent_class;
};

struct _GeeHashMultiSetPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeHashMap* _items;
	gint _nitems;
};

struct _GeeHashMultiSetIterator {
	GObject parent_instance;
	GeeHashMultiSetIteratorPrivate * priv;
};

struct _GeeHashMultiSetIteratorClass {
	GObjectClass parent_class;
};

struct _GeeUpdatableKeyIteratorIface {
	GTypeInterface parent_iface;
	gpointer (*get_value) (GeeUpdatableKeyIterator* self);
	void (*set_value) (GeeUpdatableKeyIterator* self, gconstpointer value);
};

struct _GeeHashMultiSetIteratorPrivate {
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GeeHashMultiSet* _set;
	GeeUpdatableKeyIterator* _iter;
	gint _pending;
	gboolean _removed;
};


static gpointer gee_hash_multi_set_iterator_parent_class = NULL;
static GeeIteratorIface* gee_hash_multi_set_iterator_gee_iterator_parent_iface = NULL;
static gpointer gee_hash_multi_set_parent_class = NULL;
static GeeMultiSetIface* gee_hash_multi_set_gee_multi_set_parent_iface = NULL;

GType gee_iterator_get_type (void);
GType gee_iterable_get_type (void);
GType gee_collection_get_type (void);
GType gee_abstract_collection_get_type (void);
GType gee_multi_set_get_type (void);
GType gee_hash_multi_set_get_type (void);
GType gee_abstract_map_get_type (void);
GType gee_hash_map_get_type (void);
#define GEE_HASH_MULTI_SET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEE_TYPE_HASH_MULTI_SET, GeeHashMultiSetPrivate))
enum  {
	GEE_HASH_MULTI_SET_DUMMY_PROPERTY,
	GEE_HASH_MULTI_SET_SIZE,
	GEE_HASH_MULTI_SET_HASH_FUNC,
	GEE_HASH_MULTI_SET_EQUAL_FUNC,
	GEE_HASH_MULTI_SET_G_TYPE,
	GEE_HASH_MULTI_SET_G_DUP_FUNC,
	GEE_HASH_MULTI_SET_G_DESTROY_FUNC
};
GeeAbstractCollection* gee_abstract_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func);
GeeHashMap* gee_hash_map_new (GType k_type, GBoxedCopyFunc k_dup_func, GDestroyNotify k_destroy_func, GType v_type, GBoxedCopyFunc v_dup_func, GDestroyNotify v_destroy_func, GHashFunc key_hash_func, GEqualFunc key_equal_func, GEqualFunc value_equal_func);
GeeHashMap* gee_hash_map_construct (GType object_type, GType k_type, GBoxedCopyFunc k_dup_func, GDestroyNotify k_destroy_func, GType v_type, GBoxedCopyFunc v_dup_func, GDestroyNotify v_destroy_func, GHashFunc key_hash_func, GEqualFunc key_equal_func, GEqualFunc value_equal_func);
GeeHashMultiSet* gee_hash_multi_set_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GHashFunc hash_func, GEqualFunc equal_func);
GeeHashMultiSet* gee_hash_multi_set_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GHashFunc hash_func, GEqualFunc equal_func);
gboolean gee_abstract_map_contains (GeeAbstractMap* self, gconstpointer key);
gpointer gee_abstract_map_get (GeeAbstractMap* self, gconstpointer key);
static gint gee_hash_multi_set_real_count (GeeMultiSet* base, gconstpointer item);
static gboolean gee_hash_multi_set_real_contains (GeeAbstractCollection* base, gconstpointer item);
static GeeHashMultiSetIterator* gee_hash_multi_set_iterator_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GeeHashMultiSet* set);
static GeeHashMultiSetIterator* gee_hash_multi_set_iterator_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GeeHashMultiSet* set);
static GType gee_hash_multi_set_iterator_get_type (void);
static GeeIterator* gee_hash_multi_set_real_iterator (GeeAbstractCollection* base);
void gee_abstract_map_set (GeeAbstractMap* self, gconstpointer key, gconstpointer value);
static gboolean gee_hash_multi_set_real_add (GeeAbstractCollection* base, gconstpointer item);
gboolean gee_abstract_map_remove (GeeAbstractMap* self, gconstpointer key, gpointer* value);
static gboolean gee_hash_multi_set_real_remove (GeeAbstractCollection* base, gconstpointer item);
void gee_abstract_map_clear (GeeAbstractMap* self);
static void gee_hash_multi_set_real_clear (GeeAbstractCollection* base);
GHashFunc gee_hash_map_get_key_hash_func (GeeHashMap* self);
GHashFunc gee_hash_multi_set_get_hash_func (GeeHashMultiSet* self);
GEqualFunc gee_hash_map_get_key_equal_func (GeeHashMap* self);
GEqualFunc gee_hash_multi_set_get_equal_func (GeeHashMultiSet* self);
GType gee_updatable_key_iterator_get_type (void);
#define GEE_HASH_MULTI_SET_ITERATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEE_HASH_MULTI_SET_TYPE_ITERATOR, GeeHashMultiSetIteratorPrivate))
enum  {
	GEE_HASH_MULTI_SET_ITERATOR_DUMMY_PROPERTY,
	GEE_HASH_MULTI_SET_ITERATOR_SET,
	GEE_HASH_MULTI_SET_ITERATOR_G_TYPE,
	GEE_HASH_MULTI_SET_ITERATOR_G_DUP_FUNC,
	GEE_HASH_MULTI_SET_ITERATOR_G_DESTROY_FUNC
};
static void gee_hash_multi_set_iterator_set_set (GeeHashMultiSetIterator* self, GeeHashMultiSet* value);
gboolean gee_iterator_next (GeeIterator* self);
gpointer gee_updatable_key_iterator_get_value (GeeUpdatableKeyIterator* self);
static gboolean gee_hash_multi_set_iterator_real_next (GeeIterator* base);
gboolean gee_iterator_has_next (GeeIterator* self);
static gboolean gee_hash_multi_set_iterator_real_has_next (GeeIterator* base);
static GeeHashMultiSet* gee_hash_multi_set_iterator_get_set (GeeHashMultiSetIterator* self);
gboolean gee_iterator_first (GeeIterator* self);
static gboolean gee_hash_multi_set_iterator_real_first (GeeIterator* base);
gpointer gee_iterator_get (GeeIterator* self);
static gpointer gee_hash_multi_set_iterator_real_get (GeeIterator* base);
void gee_updatable_key_iterator_set_value (GeeUpdatableKeyIterator* self, gconstpointer value);
void gee_iterator_remove (GeeIterator* self);
static void gee_hash_multi_set_iterator_real_remove (GeeIterator* base);
GeeUpdatableKeyIterator* gee_hash_map_updatable_key_iterator (GeeHashMap* self);
static GObject * gee_hash_multi_set_iterator_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void gee_hash_multi_set_iterator_finalize (GObject* obj);
static void gee_hash_multi_set_iterator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void gee_hash_multi_set_iterator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void gee_hash_multi_set_finalize (GObject* obj);
gint gee_abstract_collection_get_size (GeeAbstractCollection* self);
static void gee_hash_multi_set_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void gee_hash_multi_set_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



GeeHashMultiSet* gee_hash_multi_set_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GHashFunc hash_func, GEqualFunc equal_func) {
	GeeHashMultiSet * self;
	GeeHashMap* _tmp0_;
	self = (GeeHashMultiSet*) gee_abstract_collection_construct (object_type, g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func);
	self->priv->g_type = g_type;
	self->priv->g_dup_func = g_dup_func;
	self->priv->g_destroy_func = g_destroy_func;
	self->priv->_items = (_tmp0_ = gee_hash_map_new (g_type, (GBoxedCopyFunc) g_dup_func, g_destroy_func, G_TYPE_INT, NULL, NULL, hash_func, equal_func, g_int_equal), _g_object_unref0 (self->priv->_items), _tmp0_);
	return self;
}


GeeHashMultiSet* gee_hash_multi_set_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GHashFunc hash_func, GEqualFunc equal_func) {
	return gee_hash_multi_set_construct (GEE_TYPE_HASH_MULTI_SET, g_type, g_dup_func, g_destroy_func, hash_func, equal_func);
}


static gint gee_hash_multi_set_real_count (GeeMultiSet* base, gconstpointer item) {
	GeeHashMultiSet * self;
	gint result;
	gint _result_;
	self = (GeeHashMultiSet*) base;
	_result_ = 0;
	if (gee_abstract_map_contains ((GeeAbstractMap*) self->priv->_items, item)) {
		_result_ = GPOINTER_TO_INT (gee_abstract_map_get ((GeeAbstractMap*) self->priv->_items, item));
	}
	result = _result_;
	return result;
}


static gboolean gee_hash_multi_set_real_contains (GeeAbstractCollection* base, gconstpointer item) {
	GeeHashMultiSet * self;
	gboolean result;
	self = (GeeHashMultiSet*) base;
	result = gee_abstract_map_contains ((GeeAbstractMap*) self->priv->_items, item);
	return result;
}


static GeeIterator* gee_hash_multi_set_real_iterator (GeeAbstractCollection* base) {
	GeeHashMultiSet * self;
	GeeIterator* result;
	self = (GeeHashMultiSet*) base;
	result = (GeeIterator*) gee_hash_multi_set_iterator_new (self->priv->g_type, (GBoxedCopyFunc) self->priv->g_dup_func, self->priv->g_destroy_func, self);
	return result;
}


static gboolean gee_hash_multi_set_real_add (GeeAbstractCollection* base, gconstpointer item) {
	GeeHashMultiSet * self;
	gboolean result;
	self = (GeeHashMultiSet*) base;
	if (gee_abstract_map_contains ((GeeAbstractMap*) self->priv->_items, item)) {
		gint current_count;
		current_count = GPOINTER_TO_INT (gee_abstract_map_get ((GeeAbstractMap*) self->priv->_items, item));
		gee_abstract_map_set ((GeeAbstractMap*) self->priv->_items, item, GINT_TO_POINTER (current_count + 1));
	} else {
		gee_abstract_map_set ((GeeAbstractMap*) self->priv->_items, item, GINT_TO_POINTER (1));
	}
	self->priv->_nitems++;
	result = TRUE;
	return result;
}


static gboolean gee_hash_multi_set_real_remove (GeeAbstractCollection* base, gconstpointer item) {
	GeeHashMultiSet * self;
	gboolean result;
	gboolean _tmp0_;
	self = (GeeHashMultiSet*) base;
	_tmp0_ = FALSE;
	if (self->priv->_nitems > 0) {
		_tmp0_ = gee_abstract_map_contains ((GeeAbstractMap*) self->priv->_items, item);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint current_count;
		current_count = GPOINTER_TO_INT (gee_abstract_map_get ((GeeAbstractMap*) self->priv->_items, item));
		if (current_count <= 1) {
			gee_abstract_map_remove ((GeeAbstractMap*) self->priv->_items, item, NULL);
		} else {
			gee_abstract_map_set ((GeeAbstractMap*) self->priv->_items, item, GINT_TO_POINTER (current_count - 1));
		}
		self->priv->_nitems--;
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static void gee_hash_multi_set_real_clear (GeeAbstractCollection* base) {
	GeeHashMultiSet * self;
	self = (GeeHashMultiSet*) base;
	gee_abstract_map_clear ((GeeAbstractMap*) self->priv->_items);
	self->priv->_nitems = 0;
}


static gint gee_hash_multi_set_real_get_size (GeeAbstractCollection* base) {
	gint result;
	GeeHashMultiSet* self;
	self = (GeeHashMultiSet*) base;
	result = self->priv->_nitems;
	return result;
}


GHashFunc gee_hash_multi_set_get_hash_func (GeeHashMultiSet* self) {
	GHashFunc result;
	g_return_val_if_fail (self != NULL, NULL);
	result = gee_hash_map_get_key_hash_func (self->priv->_items);
	return result;
}


GEqualFunc gee_hash_multi_set_get_equal_func (GeeHashMultiSet* self) {
	GEqualFunc result;
	g_return_val_if_fail (self != NULL, NULL);
	result = gee_hash_map_get_key_equal_func (self->priv->_items);
	return result;
}


static GeeHashMultiSetIterator* gee_hash_multi_set_iterator_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GeeHashMultiSet* set) {
	GParameter * __params;
	GParameter * __params_it;
	GeeHashMultiSetIterator * self;
	g_return_val_if_fail (set != NULL, NULL);
	__params = g_new0 (GParameter, 4);
	__params_it = __params;
	__params_it->name = "g-type";
	g_value_init (&__params_it->value, G_TYPE_GTYPE);
	g_value_set_gtype (&__params_it->value, g_type);
	__params_it++;
	__params_it->name = "g-dup-func";
	g_value_init (&__params_it->value, G_TYPE_POINTER);
	g_value_set_pointer (&__params_it->value, g_dup_func);
	__params_it++;
	__params_it->name = "g-destroy-func";
	g_value_init (&__params_it->value, G_TYPE_POINTER);
	g_value_set_pointer (&__params_it->value, g_destroy_func);
	__params_it++;
	__params_it->name = "set";
	g_value_init (&__params_it->value, GEE_TYPE_HASH_MULTI_SET);
	g_value_set_object (&__params_it->value, set);
	__params_it++;
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


static GeeHashMultiSetIterator* gee_hash_multi_set_iterator_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GeeHashMultiSet* set) {
	return gee_hash_multi_set_iterator_construct (GEE_HASH_MULTI_SET_TYPE_ITERATOR, g_type, g_dup_func, g_destroy_func, set);
}


static gboolean gee_hash_multi_set_iterator_real_next (GeeIterator* base) {
	GeeHashMultiSetIterator * self;
	gboolean result;
	self = (GeeHashMultiSetIterator*) base;
	self->priv->_removed = FALSE;
	if (self->priv->_pending == 0) {
		if (gee_iterator_next ((GeeIterator*) self->priv->_iter)) {
			self->priv->_pending = GPOINTER_TO_INT (gee_updatable_key_iterator_get_value (self->priv->_iter)) - 1;
			result = TRUE;
			return result;
		}
	} else {
		self->priv->_pending--;
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean gee_hash_multi_set_iterator_real_has_next (GeeIterator* base) {
	GeeHashMultiSetIterator * self;
	gboolean result;
	gboolean _tmp0_;
	self = (GeeHashMultiSetIterator*) base;
	_tmp0_ = FALSE;
	if (self->priv->_pending > 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = gee_iterator_has_next ((GeeIterator*) self->priv->_iter);
	}
	result = _tmp0_;
	return result;
}


static gboolean gee_hash_multi_set_iterator_real_first (GeeIterator* base) {
	GeeHashMultiSetIterator * self;
	gboolean result;
	self = (GeeHashMultiSetIterator*) base;
	if (self->priv->_set->priv->_nitems == 0) {
		result = FALSE;
		return result;
	}
	self->priv->_pending = 0;
	if (gee_iterator_first ((GeeIterator*) self->priv->_iter)) {
		self->priv->_pending = GPOINTER_TO_INT (gee_updatable_key_iterator_get_value (self->priv->_iter)) - 1;
	}
	result = TRUE;
	return result;
}


static gpointer gee_hash_multi_set_iterator_real_get (GeeIterator* base) {
	GeeHashMultiSetIterator * self;
	gpointer result;
	self = (GeeHashMultiSetIterator*) base;
	g_assert (!self->priv->_removed);
	result = gee_iterator_get ((GeeIterator*) self->priv->_iter);
	return result;
}


static void gee_hash_multi_set_iterator_real_remove (GeeIterator* base) {
	GeeHashMultiSetIterator * self;
	self = (GeeHashMultiSetIterator*) base;
	g_assert (!self->priv->_removed);
	gee_updatable_key_iterator_set_value (self->priv->_iter, GINT_TO_POINTER (self->priv->_pending = GPOINTER_TO_INT (gee_updatable_key_iterator_get_value (self->priv->_iter)) - 1));
	if (self->priv->_pending == 0) {
		gee_iterator_remove ((GeeIterator*) self->priv->_iter);
	}
	self->priv->_removed = TRUE;
}


static GeeHashMultiSet* gee_hash_multi_set_iterator_get_set (GeeHashMultiSetIterator* self) {
	GeeHashMultiSet* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_set;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void gee_hash_multi_set_iterator_set_set (GeeHashMultiSetIterator* self, GeeHashMultiSet* value) {
	GeeHashMultiSet* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_set = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_set), _tmp0_);
	g_object_notify ((GObject *) self, "set");
}


static GObject * gee_hash_multi_set_iterator_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GeeHashMultiSetIteratorClass * klass;
	GObjectClass * parent_class;
	GeeHashMultiSetIterator * self;
	klass = GEE_HASH_MULTI_SET_ITERATOR_CLASS (g_type_class_peek (GEE_HASH_MULTI_SET_TYPE_ITERATOR));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = GEE_HASH_MULTI_SET_ITERATOR (obj);
	{
		GeeUpdatableKeyIterator* _tmp0_;
		self->priv->_iter = (_tmp0_ = gee_hash_map_updatable_key_iterator (self->priv->_set->priv->_items), _g_object_unref0 (self->priv->_iter), _tmp0_);
	}
	return obj;
}


static void gee_hash_multi_set_iterator_class_init (GeeHashMultiSetIteratorClass * klass) {
	gee_hash_multi_set_iterator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GeeHashMultiSetIteratorPrivate));
	G_OBJECT_CLASS (klass)->get_property = gee_hash_multi_set_iterator_get_property;
	G_OBJECT_CLASS (klass)->set_property = gee_hash_multi_set_iterator_set_property;
	G_OBJECT_CLASS (klass)->constructor = gee_hash_multi_set_iterator_constructor;
	G_OBJECT_CLASS (klass)->finalize = gee_hash_multi_set_iterator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_ITERATOR_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_ITERATOR_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_ITERATOR_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_ITERATOR_SET, g_param_spec_object ("set", "set", "set", GEE_TYPE_HASH_MULTI_SET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void gee_hash_multi_set_iterator_gee_iterator_interface_init (GeeIteratorIface * iface) {
	gee_hash_multi_set_iterator_gee_iterator_parent_iface = g_type_interface_peek_parent (iface);
	iface->next = gee_hash_multi_set_iterator_real_next;
	iface->has_next = gee_hash_multi_set_iterator_real_has_next;
	iface->first = gee_hash_multi_set_iterator_real_first;
	iface->get = gee_hash_multi_set_iterator_real_get;
	iface->remove = gee_hash_multi_set_iterator_real_remove;
}


static void gee_hash_multi_set_iterator_instance_init (GeeHashMultiSetIterator * self) {
	self->priv = GEE_HASH_MULTI_SET_ITERATOR_GET_PRIVATE (self);
	self->priv->_pending = 0;
	self->priv->_removed = FALSE;
}


static void gee_hash_multi_set_iterator_finalize (GObject* obj) {
	GeeHashMultiSetIterator * self;
	self = GEE_HASH_MULTI_SET_ITERATOR (obj);
	_g_object_unref0 (self->priv->_set);
	_g_object_unref0 (self->priv->_iter);
	G_OBJECT_CLASS (gee_hash_multi_set_iterator_parent_class)->finalize (obj);
}


static GType gee_hash_multi_set_iterator_get_type (void) {
	static GType gee_hash_multi_set_iterator_type_id = 0;
	if (gee_hash_multi_set_iterator_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GeeHashMultiSetIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gee_hash_multi_set_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GeeHashMultiSetIterator), 0, (GInstanceInitFunc) gee_hash_multi_set_iterator_instance_init, NULL };
		static const GInterfaceInfo gee_iterator_info = { (GInterfaceInitFunc) gee_hash_multi_set_iterator_gee_iterator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		gee_hash_multi_set_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "GeeHashMultiSetIterator", &g_define_type_info, 0);
		g_type_add_interface_static (gee_hash_multi_set_iterator_type_id, GEE_TYPE_ITERATOR, &gee_iterator_info);
	}
	return gee_hash_multi_set_iterator_type_id;
}


static void gee_hash_multi_set_iterator_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GeeHashMultiSetIterator * self;
	self = GEE_HASH_MULTI_SET_ITERATOR (object);
	switch (property_id) {
		case GEE_HASH_MULTI_SET_ITERATOR_SET:
		g_value_set_object (value, gee_hash_multi_set_iterator_get_set (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gee_hash_multi_set_iterator_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GeeHashMultiSetIterator * self;
	self = GEE_HASH_MULTI_SET_ITERATOR (object);
	switch (property_id) {
		case GEE_HASH_MULTI_SET_ITERATOR_SET:
		gee_hash_multi_set_iterator_set_set (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case GEE_HASH_MULTI_SET_ITERATOR_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case GEE_HASH_MULTI_SET_ITERATOR_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case GEE_HASH_MULTI_SET_ITERATOR_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}


static void gee_hash_multi_set_class_init (GeeHashMultiSetClass * klass) {
	gee_hash_multi_set_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GeeHashMultiSetPrivate));
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->contains = gee_hash_multi_set_real_contains;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->iterator = gee_hash_multi_set_real_iterator;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->add = gee_hash_multi_set_real_add;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->remove = gee_hash_multi_set_real_remove;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->clear = gee_hash_multi_set_real_clear;
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->get_size = gee_hash_multi_set_real_get_size;
	G_OBJECT_CLASS (klass)->get_property = gee_hash_multi_set_get_property;
	G_OBJECT_CLASS (klass)->set_property = gee_hash_multi_set_set_property;
	G_OBJECT_CLASS (klass)->finalize = gee_hash_multi_set_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_G_TYPE, g_param_spec_gtype ("g-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_G_DUP_FUNC, g_param_spec_pointer ("g-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_G_DESTROY_FUNC, g_param_spec_pointer ("g-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_override_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_SIZE, "size");
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_HASH_FUNC, g_param_spec_pointer ("hash-func", "hash-func", "hash-func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEE_HASH_MULTI_SET_EQUAL_FUNC, g_param_spec_pointer ("equal-func", "equal-func", "equal-func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void gee_hash_multi_set_gee_multi_set_interface_init (GeeMultiSetIface * iface) {
	gee_hash_multi_set_gee_multi_set_parent_iface = g_type_interface_peek_parent (iface);
	iface->count = gee_hash_multi_set_real_count;
}


static void gee_hash_multi_set_instance_init (GeeHashMultiSet * self) {
	self->priv = GEE_HASH_MULTI_SET_GET_PRIVATE (self);
	self->priv->_nitems = 0;
}


static void gee_hash_multi_set_finalize (GObject* obj) {
	GeeHashMultiSet * self;
	self = GEE_HASH_MULTI_SET (obj);
	_g_object_unref0 (self->priv->_items);
	G_OBJECT_CLASS (gee_hash_multi_set_parent_class)->finalize (obj);
}


GType gee_hash_multi_set_get_type (void) {
	static GType gee_hash_multi_set_type_id = 0;
	if (gee_hash_multi_set_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GeeHashMultiSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gee_hash_multi_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GeeHashMultiSet), 0, (GInstanceInitFunc) gee_hash_multi_set_instance_init, NULL };
		static const GInterfaceInfo gee_multi_set_info = { (GInterfaceInitFunc) gee_hash_multi_set_gee_multi_set_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		gee_hash_multi_set_type_id = g_type_register_static (GEE_TYPE_ABSTRACT_COLLECTION, "GeeHashMultiSet", &g_define_type_info, 0);
		g_type_add_interface_static (gee_hash_multi_set_type_id, GEE_TYPE_MULTI_SET, &gee_multi_set_info);
	}
	return gee_hash_multi_set_type_id;
}


static void gee_hash_multi_set_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GeeHashMultiSet * self;
	self = GEE_HASH_MULTI_SET (object);
	switch (property_id) {
		case GEE_HASH_MULTI_SET_SIZE:
		g_value_set_int (value, gee_abstract_collection_get_size ((GeeAbstractCollection*) self));
		break;
		case GEE_HASH_MULTI_SET_HASH_FUNC:
		g_value_set_pointer (value, gee_hash_multi_set_get_hash_func (self));
		break;
		case GEE_HASH_MULTI_SET_EQUAL_FUNC:
		g_value_set_pointer (value, gee_hash_multi_set_get_equal_func (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gee_hash_multi_set_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GeeHashMultiSet * self;
	self = GEE_HASH_MULTI_SET (object);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
		case GEE_HASH_MULTI_SET_G_TYPE:
		self->priv->g_type = g_value_get_gtype (value);
		break;
		case GEE_HASH_MULTI_SET_G_DUP_FUNC:
		self->priv->g_dup_func = g_value_get_pointer (value);
		break;
		case GEE_HASH_MULTI_SET_G_DESTROY_FUNC:
		self->priv->g_destroy_func = g_value_get_pointer (value);
		break;
	}
}




